// CedarFTPDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "CedarFTP.h"
#include "CedarFTPDlg.h"
#include "LoginDialog.h"
#include "AboutDialog.h"
#include "CreateDirDialog.h"
#include "PermissionDialog.h"
#include "MessageDialog.h"
#include "MoveDialog.h"
#include "SettingPage1.h"
#include "SettingPage2.h"
#include "SettingPage3.h"
#include "CedarReg.h"
#include <stdlib.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

const CString csVersionInfo = L"CedarFTP -Seed Edition- v0.16 Build 50          Proposed by uema2.";

/////////////////////////////////////////////////////////////////////////////
// CCedarFTPDlg _CAO

CCedarFTPDlg::CCedarFTPDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCedarFTPDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCedarFTPDlg)
	m_dir_local = _T("");
	m_dir_remote = _T("");
	//}}AFX_DATA_INIT
	//  : LoadIcon  Win32  DestroyIcon ̃TuV[PXv܂
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CCedarFTPDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCedarFTPDlg)
	DDX_Control(pDX, IDB_MOVE, m_move);
	DDX_Control(pDX, IDB_AUTO, m_auto);
	DDX_Control(pDX, IDB_PERMISSION, m_permission);
	DDX_Control(pDX, IDB_DOWNLOAD, m_download);
	DDX_Control(pDX, IDB_UPLOAD, m_upload);
	DDX_Control(pDX, IDB_REMOTE_DEL, m_del_remote);
	DDX_Control(pDX, IDB_REMOTE_OPEN, m_open_remote);
	DDX_Control(pDX, IDB_REMOTE_NEW, m_new_remote);
	DDX_Control(pDX, IDB_DISCONNECT, m_disconnect);
	DDX_Control(pDX, IDB_CONNECT, m_connect);
	DDX_Control(pDX, IDB_BINARY, m_binary);
	DDX_Control(pDX, IDB_ASCII, m_ascii);
	DDX_Control(pDX, IDC_PROGRESS, m_progress);
	DDX_Control(pDX, IDC_REMOTE_LIST, m_list_remote);
	DDX_Control(pDX, IDC_LOCAL_LIST, m_list_local);
	DDX_Text(pDX, IDE_LOCAL, m_dir_local);
	DDX_Text(pDX, IDE_REMOTE, m_dir_remote);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCedarFTPDlg, CDialog)
	//{{AFX_MSG_MAP(CCedarFTPDlg)
	ON_BN_CLICKED(IDC_CONNECT, OnConnect)
	ON_BN_CLICKED(IDC_DISCONNECT, OnDisconnect)
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDB_UPLOAD, OnUpload)
	ON_BN_CLICKED(IDB_LOCAL_OPEN, OnLocalOpen)
	ON_BN_CLICKED(IDB_ASCII, OnAscii)
	ON_BN_CLICKED(IDB_BINARY, OnBinary)
	ON_BN_CLICKED(IDB_DOWNLOAD, OnDownload)
	ON_BN_CLICKED(IDB_REMOTE_OPEN, OnRemoteOpen)
	ON_LBN_DBLCLK(IDC_LOCAL_LIST, OnDblclkLocalList)
	ON_LBN_DBLCLK(IDC_REMOTE_LIST, OnDblclkRemoteList)
	ON_BN_CLICKED(IDB_LOCAL_NEW, OnLocalNewDir)
	ON_BN_CLICKED(IDB_REMOTE_NEW, OnRemoteNewDir)
	ON_BN_CLICKED(IDB_LOCAL_DEL, OnLocalDel)
	ON_BN_CLICKED(IDB_REMOTE_DEL, OnRemoteDel)
	ON_BN_CLICKED(IDB_PERMISSION, OnPermission)
	ON_BN_CLICKED(IDB_SETTINGS, OnSettings)
	ON_BN_CLICKED(IDB_AUTO, OnAuto)
	ON_BN_CLICKED(IDB_MOVE, OnMove)
	ON_BN_CLICKED(IDOK, OnOK)
	ON_COMMAND(IDA_FOCUSLOCAL, OnFocuslocal)
	ON_COMMAND(IDA_FOCUSREMOTE, OnFocusremote)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCedarFTPDlg bZ[W nh
void CCedarFTPDlg::OnOK()
{
//	CDialog::OnOK();

	CDirListBox* w = (CDirListBox*)GetFocus();
	int id = w->GetDlgCtrlID();

	if( id==IDC_LOCAL_LIST )
		OnLocalOpen();
	else if( id==IDC_REMOTE_LIST )
		OnRemoteOpen();
}

BOOL CCedarFTPDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// ̃_CAOp̃ACRݒ肵܂BAvP[ṼC EBhE_CAO
	//  ȂƂ̓t[[N͎Iɍs܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(m_hIcon, FALSE);		// ACRݒ
	
	CenterWindow(GetDesktopWindow());	// HPC ʂ֑̒܂

	// TODO: ǉ̏sƂɂ͂̏ꏊɒǉĂB

	// [J̃t@CXg\
	m_dir_local = L"\\";
	m_list_local.EnumLocalFile(m_dir_local);

	// [g̃Rg[gps\
	EnableRemoteControls(FALSE);

	UpdateData(FALSE);
	
	// o[W\
	m_progress.SetWindowText(csVersionInfo);
	m_progress.SetFocus();

	// ʂONȂ[A/B]{^ON
	if(CCedarReg::GetBinary(L"AutoTransferMode")){
		m_auto.SetState(TRUE);
	}else{
		m_ascii.SetState(TRUE);
	}

	// uN[ڑ]_CAOovONȂ
	// _CAOo
	if(CCedarReg::GetBinary(L"ConnectDlgWithStartup")){
		ShowWindow(SW_SHOW);
		OnConnect();
	}

//	return TRUE;  // Rg[ɃtH[JXݒ肵Ȃꍇ TRUE Ԃ܂
	return FALSE;
}

void CCedarFTPDlg::OnConnect() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ

	// OC_CAO\
	CLoginDialog ld;
	int iRet = ld.DoModal();

	if( iRet != IDOK ) return;

	// ̓~X璆~
	if(ld.m_servername.IsEmpty() 
		|| ld.m_username.IsEmpty()
		|| ld.m_password.IsEmpty()){

		AfxMessageBox(L"͂ĂȂڂ܂.");
		return;
	}

	// ڑ_CAOo
	if(TRUE == CCedarReg::GetBinary(L"UseAutoDialUp")){
		CString csRasName = CCedarReg::GetString(L"AutoDialUpName");
		// ڑ
		RASDIALPARAMS rasprm;
		BOOL bret;
		DWORD dwret;

		memset( &rasprm, 0x00, sizeof(RASDIALPARAMS) );
		rasprm.dwSize = sizeof(RASDIALPARAMS);
		lstrcpy( rasprm.szEntryName, csRasName); 

		dwret = ::RasGetEntryDialParams( 
					NULL, &rasprm, &bret);
		// QԖڂ̈ɁA[U[
		//   pX[hȂǂ̏񂪓܂B
		// RԖڂɂ́AQԖڂɃ[U[
		//     pX[hĂꍇ́A
		// TRUEŕԂ܂B
		if( dwret != 0 ){
			AfxMessageBox(L"ڑɎs܂\nRasGetEntryDialParams Failed");
			return;
		}

		//u҂ṽ_CAOo
		if(csRasName.GetLength()>10)
			CreateMessageDialog(csRasName.Left(10) + L"..ɐڑł\n΂炭҂...");
		else
			CreateMessageDialog(csRasName + L"ɐڑł\n΂炭҂...");

		// ڑ
		dwret = ::RasDial( NULL, NULL, &rasprm, 
			NULL, (void *)&CUeUtil::RasCallback, &m_hrasconn);
		// łɐڑĂꍇ 602 ԂHE`H
		if( dwret != 0 && dwret != 602 ){
			AfxMessageBox( L"ڑɎs܂\nRasDial Failed");
			return;
		}

		DWORD dwRet;
		RASCONNSTATUS rasconnstatus;
		rasconnstatus.dwSize = sizeof(RASCONNSTATUS);
		// ȈՃ^CAEg@\
		DWORD start = ::GetTickCount();
		DWORD timeout = CCedarReg::GetDword(L"ConnectTimeout");
		if( timeout==0 ) timeout = 90*1000;
		else             timeout*= 1000;
//		DWORD timeout = 90*1000, now=::GetTickCount();
		while(1){
			dwRet = RasGetConnectStatus(m_hrasconn, &rasconnstatus);
			// ڑɐ甲
			if(dwRet!=0 || rasconnstatus.rasconnstate == RASCS_Connected)
				break;
			// ^CAEgԂɒB甲
			if( start+timeout <= ::GetTickCount() )
			{ ::AfxMessageBox( L"ڑ^CAEgł" ); return; }
			Sleep(0);
		}

	}

	//u҂ṽ_CAOo
	CreateMessageDialog(L"OCłB\n΂炭҂...");

	// ڑ
	BOOL bResult = m_ftp.ConnectToServer( ld.m_servername, 21 );
	if( ! bResult ){
		m_progress.SetWindowText(L"ConnectToServer Ɏs\r\n");
		return;
	}

	m_progress.SetWindowText(m_ftp.GetStatusFromServer());

	// OC
	bResult = m_ftp.UserLogin( ld.m_username, ld.m_password );
	if( ! bResult ){
		m_progress.SetWindowText(L"UserLogin Ɏs\r\n");
		return;
	}

	m_progress.SetWindowText(m_ftp.GetStatusFromServer());

	// [ǧ݂̃fBNg擾
	CString csDir = m_ftp.GetWorkingDirectory();
	m_progress.SetWindowText(m_ftp.GetStatusFromServer());

	// Ń[gfBNgύX(KvȂ)
	if(ld.m_remotedir!=L""){
		// KvȂƂ
		m_dir_remote = ld.m_remotedir;

		m_ftp.SetWorkingDirectory(m_dir_remote);
		m_progress.SetWindowText(m_ftp.GetStatusFromServer());
	}else{
		// KvȂ炵Ƃ
		m_dir_remote = csDir;
	}
/*
	// for Debug
	csDir = m_ftp.GetWorkingDirectory();
	TCHAR lpTemp[512];
	wsprintf(lpTemp, L"csDir : %s\nm_dir_remote : %s", csDir, m_dir_remote);
	AfxMessageBox(lpTemp);
*/
	// fBNg̐ݒ肪ԈĂȂ炱ŏC
	csDir = m_ftp.GetWorkingDirectory();
	if(m_dir_remote != csDir){
		m_dir_remote = csDir;
	}

	// [gt@C
	m_list_remote.EnumRemoteFile( csDir, m_ftp, m_remoteinfo );
	if(TRUE==m_ftp.IsPASVMode()){
		m_progress.SetWindowText(L"use PASV.");
	}

	// Ń[JfBNgύX(KvȂ)
	if(ld.m_localdir!=L""){
		m_dir_local = ld.m_localdir;
		// [gfBNgłȂAŌ \ Ăꍇ͎菜
		if(m_dir_local!=L"\\" && m_dir_local[m_dir_local.GetLength()-1]==L'\\'){
			m_dir_local = m_dir_local.Left(m_dir_local.GetLength()-1);
		}
		if(FALSE==m_list_local.EnumLocalFile(m_dir_local)){
			m_dir_local = L"\\";
			m_list_local.EnumLocalFile(m_dir_local);
		}
	}

	// [g̃{^ނL
	// [ڑ]{^𖳌ɁA[ؒf]{^L
	EnableRemoteControls(TRUE);

	UpdateData(FALSE);
}

void CCedarFTPDlg::OnDisconnect() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ

	// ؒf
	m_ftp.DisconnectFromServer();

	// T[o[̉\
	m_progress.SetWindowText(m_ftp.GetStatusFromServer());

	// [g̃{^ނ𖳌
	EnableRemoteControls(FALSE);

	// fBNgɂ
	m_dir_remote = L"";
	m_list_remote.ResetContent();

	// ؒf
	if(TRUE == CCedarReg::GetBinary(L"UseAutoDialUp")){
	//u҂ṽ_CAOo
	CreateMessageDialog(L"ؒfłB\n΂炭҂...");
		RasHangUp(m_hrasconn);

		DWORD dwRet;
		RASCONNSTATUS rasconnstatus;
		rasconnstatus.dwSize = sizeof(RASCONNSTATUS);
		while(1){
			dwRet = RasGetConnectStatus(m_hrasconn, &rasconnstatus);
			if(dwRet!=0 || rasconnstatus.rasconnstate == RASCS_Disconnected)
				break;
			Sleep(0);
		}
	}

	UpdateData(FALSE);
}

void CCedarFTPDlg::OnClose() 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	OnDisconnect();
	
	CDialog::OnClose();
}

void CCedarFTPDlg::OnUpload() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CString csFileName, csLocalFile, csTemp;
	BOOL bResult;
	int rc;

	UpdateData(TRUE);

	// IĂ邩m
	int iCount = m_list_local.GetSelCount();

	// ȂɂIĂȂ璆~
	if(iCount==0) return;

	csTemp.Format(L"%d ̃t@CAbv[h܂H", iCount);
	rc = AfxMessageBox(csTemp, MB_YESNO);

	if(rc == IDNO) return;

	// IĂ鍀ڂ̔ԍi[z
	int *iIndex = new int[iCount+1];

	// zɍڂ̔ԍi[
	m_list_local.GetSelItems(iCount+1, iIndex);

	// O擾
	for(int i=0;i<iCount;i++){
		m_list_local.GetText(iIndex[i], csFileName);

		// tH_Ȃ疳
		if(0 == csFileName.Find(L"<")) continue;

		// Abv[h
		bResult = m_ftp.Upload(m_dir_local, m_dir_remote, csFileName, m_remoteinfo);
		if( ! bResult ){
			csTemp.Format(L"%s ̃Abv[hɎs܂\r\n", csFileName);
			continue;
		}

		csTemp.Format(L"%s ̃Abv[hɏI܂", csLocalFile);
		m_progress.SetWindowText(csTemp);

	}

	// Xgr[XV
	m_list_remote.EnumRemoteFile(m_dir_remote, m_ftp, m_remoteinfo);

//	m_progress.SetWindowText(L"Abv[h܂");	
	m_progress.SetWindowText(m_ftp.GetStatusFromServer());	

	UpdateData(FALSE);

	// z
	delete [] iIndex;

}

void CCedarFTPDlg::OnLocalOpen() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ

	// IĂ̂tH_ȂJ
	CString csDir;

	UpdateData(TRUE);
	m_list_local.GetText(m_list_local.GetCaretIndex(), csDir);

	if(csDir == L".."){

		// ̃fBNgֈړ
		UpdateData(TRUE);
		int Pos = m_dir_local.ReverseFind(L'\\');
		m_dir_local = m_dir_local.Left(Pos);

		if(m_dir_local.IsEmpty()==TRUE){
			m_dir_local = L"\\";
			m_list_local.EnumLocalFile(L"");
		}else{
			m_list_local.EnumLocalFile(m_dir_local);
		}

		UpdateData(FALSE);

	}else{

		int Pos = csDir.Find(L"<");
		if(Pos != 0){
			//tH_Ȃ̂ł܂
			return;
		}else{
			int length = csDir.GetLength();
			csDir = csDir.Mid(1, length-2);
	
			if(m_dir_local==L"\\") m_dir_local = m_dir_local + csDir;
			else m_dir_local = m_dir_local + L"\\" + csDir;

			m_list_local.EnumLocalFile(m_dir_local);
			UpdateData(FALSE);
		}

	}
}

void CCedarFTPDlg::OnAscii() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ

	// AXL[[hɕύX
	m_binary.SetState(FALSE);
	m_ascii.SetState(TRUE);
	m_auto.SetState(FALSE);
	CCedarReg::SetBinary(L"AutoTransferMode", FALSE);
	
	m_ftp.SetTransferModeAscii();
}

void CCedarFTPDlg::OnBinary() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ

	// oCi[hɕύX
	m_binary.SetState(TRUE);
	m_ascii.SetState(FALSE);
	m_auto.SetState(FALSE);
	CCedarReg::SetBinary(L"AutoTransferMode", FALSE);

	m_ftp.SetTransferModeImage();
}

void CCedarFTPDlg::OnAuto() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	// 
	m_binary.SetState(FALSE);
	m_ascii.SetState(FALSE);
	m_auto.SetState(TRUE);

	CCedarReg::SetBinary(L"AutoTransferMode", TRUE);
}

void CCedarFTPDlg::OnDownload() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CString csFileName, csLocalFile, csTemp;
	BOOL bResult;
	int rc;

	UpdateData(TRUE);
	// IĂ邩m
	int iCount = m_list_remote.GetSelCount();
	
	// ȂɂIĂȂ璆~
	if(iCount==0) return;

	csTemp.Format(L"%d ̃t@C_E[h܂H", iCount);
	rc = AfxMessageBox(csTemp, MB_YESNO);

	if(rc == IDNO) return;

	// IĂ鍀ڂ̔ԍi[z
	int *iIndex = new int[iCount+1];

	// zɍڂ̔ԍi[
	m_list_remote.GetSelItems(iCount+1, iIndex);

	int j=0, flag=0;

	for(int i=0;i<iCount;i++){
		// O擾
		m_list_remote.GetText(iIndex[i], csFileName);

		// tH_Ȃ疳
		if(0 == csFileName.Find(L"<")) continue;

		// _E[h
		bResult = m_ftp.Download( m_dir_local, m_dir_remote, 
			csFileName, m_remoteinfo ) ;
		if( ! bResult ){
			m_progress.SetWindowText(L"_E[hɎs܂");	
			continue;
		}

		csTemp.Format(L"%s ̃_E[hɏI܂", csFileName);
		m_progress.SetWindowText(csTemp);
	}

	// Xgr[XV
	m_list_local.EnumLocalFile(m_dir_local);

//	m_progress.SetWindowText(L"_E[h܂");	
	m_progress.SetWindowText(m_ftp.GetStatusFromServer());	

	UpdateData(FALSE);

	// z
	delete [] iIndex;

}

void CCedarFTPDlg::OnRemoteOpen() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CString csDir;

	UpdateData(TRUE);
	m_list_remote.GetText(m_list_remote.GetCaretIndex(), csDir);

	CreateMessageDialog(L"t@CXg擾łB\n΂炭҂...");

	if(csDir == L".."){

		// ̃fBNgֈړ
		int Pos = m_dir_remote.ReverseFind(L'/');
		m_dir_remote = m_dir_remote.Left(Pos);

		// [gfBNĝƂ
		if(m_dir_remote.IsEmpty()==TRUE){
			m_dir_remote = L"/";
			m_ftp.SetWorkingDirectory(m_dir_remote);
			m_list_remote.EnumRemoteFile(L"", m_ftp, m_remoteinfo);
		// ȊÔƂ
		}else{
			m_ftp.SetWorkingDirectory(csDir);
			m_dir_remote = m_ftp.GetWorkingDirectory();
			m_list_remote.EnumRemoteFile(m_dir_remote, m_ftp, m_remoteinfo);
		}

	}else{

		int Pos = csDir.Find(L"<");

		if(Pos != 0) return;

		int length = csDir.GetLength();
		csDir = csDir.Mid(1, length-2);

		if(m_dir_remote==L"/") m_dir_remote = m_dir_remote + csDir;
		else m_dir_remote = m_dir_remote + L"/" + csDir;

		m_ftp.SetWorkingDirectory(csDir); 
		m_list_remote.EnumRemoteFile(csDir, m_ftp, m_remoteinfo);

	}

	UpdateData(FALSE);
}

void CCedarFTPDlg::OnDblclkLocalList() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CString csDir;

	m_list_local.GetText(m_list_local.GetCaretIndex(), csDir);

	if(0 == csDir.Find(L"<") || csDir == L"..")
		OnLocalOpen();

}

void CCedarFTPDlg::OnDblclkRemoteList() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CString csDir;

	m_list_remote.GetText(m_list_remote.GetCaretIndex(), csDir);

	if(0 == csDir.Find(L"<") || csDir == L"..")
		OnRemoteOpen();

}

void CCedarFTPDlg::OnLocalNewDir() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CCreateDirDialog cdd;
	CString csDir;

	int iRet = cdd.DoModal();

	if(iRet == IDOK){
		if(cdd.m_new_dir.IsEmpty()) return;

		UpdateData(TRUE);

		if(m_dir_local==L"\\") csDir = m_dir_local + cdd.m_new_dir;
		else csDir = m_dir_local + L"\\" + cdd.m_new_dir;

		::CreateDirectory(csDir, NULL);

		m_list_local.EnumLocalFile(m_dir_local);

		UpdateData(FALSE);
	}

}

void CCedarFTPDlg::OnRemoteNewDir() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CCreateDirDialog cdd;
	CString csDir;

	int iRet = cdd.DoModal();

	if(iRet == IDOK){
		if(cdd.m_new_dir.IsEmpty()) return;

		UpdateData(TRUE);

		BOOL bResult = m_ftp.MakeDirectory( cdd.m_new_dir ) ;
		if( ! bResult ){
			m_progress.SetWindowText(L"fBNg쐬Ɏs܂");	
			return;
		}

		m_list_remote.EnumRemoteFile(m_dir_remote, m_ftp, m_remoteinfo);
		UpdateData(FALSE);

	}

}

void CCedarFTPDlg::OnLocalDel() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CString csFileName, csLocalFile, csTemp;
	int rc;

	UpdateData(TRUE);

	// IĂ邩m
	int iCount = m_list_local.GetSelCount();

	// ȂɂIĂȂ璆~
	if(iCount==0) return;

	csTemp.Format(L"%d ̃t@C폜܂H", iCount);
	rc = AfxMessageBox(csTemp, MB_YESNO);

	if(rc == IDNO) return;

	// IĂ鍀ڂ̔ԍi[z
	int *iIndex = new int[iCount+1];

	// zɍڂ̔ԍi[
	m_list_local.GetSelItems(iCount+1, iIndex);

	// O擾
	for(int i=0;i<iCount;i++){
		m_list_local.GetText(iIndex[i], csFileName);

		if(csFileName == L"..") continue;

		// tH_Ȃ疳?
		if(0 == csFileName.Find(L"<")){
		
			// tH_
			// <  > ؂
			int iLength = csFileName.GetLength();
			csFileName = csFileName.Mid(1, iLength-2);

			if(m_dir_local==L"\\") csLocalFile = m_dir_local + csFileName;
			else csLocalFile = m_dir_local + L"\\" + csFileName;
			// ̊֐AfBNgɃt@C
			// s
			RemoveDirectory(csLocalFile);

		}else{

			if(m_dir_local==L"\\") csLocalFile = m_dir_local + csFileName;
			else csLocalFile = m_dir_local + L"\\" + csFileName;

			DeleteFile(csLocalFile);

			csTemp.Format(L"%s 폜܂", csLocalFile);
			m_progress.SetWindowText(csTemp);
		}
	}

	// Xgr[XV
	m_list_local.EnumLocalFile(m_dir_local);

	m_progress.SetWindowText(L"폜܂");
	UpdateData(FALSE);

	// z
	delete [] iIndex;
	
}

void CCedarFTPDlg::OnRemoteDel() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CString csFileName, csLocalFile, csTemp;
	BOOL bResult;
	int rc;

	UpdateData(TRUE);
	// IĂ邩m
	int iCount = m_list_remote.GetSelCount();

	// ȂɂIĂȂȂ璆~
	if(iCount==0) return;

	csTemp.Format(L"%d ̃t@C܂\nfBNg폜܂H", iCount);
	rc = AfxMessageBox(csTemp, MB_YESNO);

	if(rc == IDNO) return;

	// IĂ鍀ڂ̔ԍi[z
	int *iIndex = new int[iCount+1];

	// zɍڂ̔ԍi[
	m_list_remote.GetSelItems(iCount+1, iIndex);

	// O擾
	for(int i=0;i<iCount;i++){
		m_list_remote.GetText(iIndex[i], csFileName);

		// ".." ̓pX
		if(csFileName==L"..") continue;

		// tH_
		if(0 == csFileName.Find(L"<")){

			// <  > ؂
			int iLength = csFileName.GetLength();
			csFileName = csFileName.Mid(1, iLength-2);
/*
			// fBNĝׂẴt@C擾āA
			// ÂȂႾ߂H
			// ChJ[h͎gȂ̂H
			// SITE rm -r ƂłȂ̂H
			CString csAllFile = csFileName + L"/*";
			// fBNg̃t@CSč폜H
			bResult = m_ftp.RemoveFile( csAllFile ) ;
			if( ! bResult ){
				m_progress.SetWindowText(L"t@C̍폜Ɏs܂");
				continue;
			}
*/
			// fBNg̍폜
			m_ftp.RemoveDirectory(csFileName);
			if( ! bResult ){
				m_progress.SetWindowText(L"fBNg폜Ɏs܂");
				continue;
			}
			csTemp.Format(L"%s ̍폜ɏI܂", csFileName);
			m_progress.SetWindowText(csTemp);

		}else{

			// [gt@C
			if(m_dir_remote==L"/") csFileName = m_dir_remote + csFileName;
			else csFileName = m_dir_remote + L"/" + csFileName;

			// t@C폜
			bResult = m_ftp.RemoveFile( csFileName ) ;
			if( ! bResult ){
				m_progress.SetWindowText(L"폜Ɏs܂");
				continue;
			}
			// \
			csTemp.Format(L"%s ̍폜ɏI܂", csFileName);
			m_progress.SetWindowText(csTemp);
		}
	}

	// Xgr[XV
	m_list_remote.EnumRemoteFile(m_dir_remote, m_ftp, m_remoteinfo);

	m_progress.SetWindowText(L"폜܂");	
	UpdateData(FALSE);

	// z
	delete [] iIndex;
}

void CCedarFTPDlg::OnPermission() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	///// p[~bV̕ύX

	// IĂt@C擾
	int iSelected = m_list_remote.GetCaretIndex();

	CString csFileName;
	m_list_remote.GetText(iSelected, csFileName);

	// fBNg炨܂
//	if(csFileName[0]==L'<' || csFileName== L"..") return;
	if(csFileName== L".." || csFileName== L"." ||
		csFileName== L"<..>" || csFileName== L"<.>")
		return;
/*
	if(csFileName[0]==L'<'){
		// fBNgȂO < > 폜
		csFileName = csFileName.Mid(1, csFileName.GetLength()-2);
	}

	int i=0, iFind=0;
	while(iFind==0 && m_remoteinfo[i].m_filename!=L"*end*"){
		if(m_remoteinfo[i].m_filename==csFileName) iFind=1;
		i++;
	}
*/
	// t@C m_remoteinfo 猟
	int i=0;
	while(1){
		if(m_remoteinfo[i].m_filename==L"*end*"){
			// Ȃ΂܂
			m_progress.SetWindowText(
				L"w肳ꂽt@CXgɂ܂\r\n");
			return;
		}
		if(m_remoteinfo[i].m_filename==csFileName)
			break;
		i++;
	}

#ifdef DEBUG
	AfxMessageBox(L"getList end");
#endif

	// ݂̃p[~bV擾ĕ\
	CPermissionDialog pmd;
//	pmd.GetCurrentPermission(m_remoteinfo, i-1);
	pmd.GetCurrentPermission(m_remoteinfo, i);

	// p[~bVύX_CAO\
	int iRet = pmd.DoModal();

	if(iRet != IDOK) return;

	// p[~bVύX
	CString csPermission;
	pmd.GetNewPermission(csPermission);

	CString name = m_remoteinfo[i].m_filename;
	if( name[0] == L'<' ){
		// fBNgȂO < > 폜
		name = name.Mid(1, name.GetLength()-2);
	}

//	BOOL bResult = m_ftp.ChangeFileAttrib(m_remoteinfo[i-1].m_filename, csPermission);
	BOOL bResult = m_ftp.ChangeFileAttrib(
		name, csPermission);
	if( ! bResult ){
		m_progress.SetWindowText(L"ChangeFileAttrib Ɏs\r\n");
		return;
	}

	m_progress.SetWindowText(m_ftp.GetStatusFromServer());

	// Xgr[XV
	m_list_remote.EnumRemoteFile(m_dir_remote, m_ftp, m_remoteinfo);

}

void CCedarFTPDlg::OnMove() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ

	// IĂt@C擾
	int iSelected = m_list_remote.GetCaretIndex();

	CString csFileName;
	m_list_remote.GetText(iSelected, csFileName);

	// fBNg炨܂
	if(csFileName[0]==L'<' || csFileName== L"..") return;

	// t@C m_remoteinfo 猟
	int i=0, iFind=0;
	while(iFind==0 && m_remoteinfo[i].m_filename!=L"*end*"){
		if(m_remoteinfo[i].m_filename==csFileName) iFind=1;
		i++;
	}

	// _CAOoāAړ̃t@C
	CMoveDialog md;
	md.m_new_name = m_remoteinfo[i-1].m_filename;
//	md.GetDlgItem(IDC_EDIT1)->SetFocus();
	int iRet = md.DoModal();

	if(iRet != IDOK) return;

	if(md.m_new_name.IsEmpty()) return;

	UpdateData(TRUE);

	BOOL bResult = m_ftp.MoveFile( m_remoteinfo[i-1].m_filename, md.m_new_name ) ;
	if( ! bResult ){
		m_progress.SetWindowText(L"l[Ɏs܂");	
		return;
	}

	m_list_remote.EnumRemoteFile(m_dir_remote, m_ftp, m_remoteinfo);
	UpdateData(FALSE);
}

void CCedarFTPDlg::CreateMessageDialog(CString csMessage)
{
	CMessageDialog md;

	md.m_message = csMessage;
	md.Create(IDD_MESSAGE_DIALOG);

	md.DestroyWindow();

}

void CCedarFTPDlg::EnableRemoteControls(BOOL b)
{
	// [ڑ]{^𖳌ɁA[ؒf]{^L
	m_connect.EnableWindow(!b);
	m_disconnect.EnableWindow(b);

	// [g̃{^ނL
	m_new_remote.EnableWindow(b);
	m_open_remote.EnableWindow(b);
	m_del_remote.EnableWindow(b);
	m_upload.EnableWindow(b);
	m_download.EnableWindow(b);
	m_permission.EnableWindow(b);
	m_move.EnableWindow(b);
}

void CCedarFTPDlg::OnSettings() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	{
	CSettingPage1 p1;
	CSettingPage2 p2;
	CSettingPage3 p3;

	CPropertySheet ps(L"CedarFTP ݒ", this);

	ps.AddPage(&p1); ps.AddPage(&p2); ps.AddPage(&p3);

	if(IDOK != ps.DoModal())
		return;
	}

	if(CCedarReg::GetBinary(L"AutoTransferMode")){
		m_ascii.SetState(FALSE);
		m_binary.SetState(FALSE);
		m_auto.SetState(TRUE);
	}else{
		m_ascii.SetState(TRUE);
		m_auto.SetState(FALSE);
		m_ftp.SetTransferModeAscii();
	}

}


void CCedarFTPDlg::OnFocuslocal() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	m_list_local.SetFocus();
}

void CCedarFTPDlg::OnFocusremote() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	m_list_remote.SetFocus();
	
}
