// CedarReg.cpp: CCedarReg NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "CedarFTP.h"
#include "CedarReg.h"
#include "RegKey.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

CString CCedarReg::csTempSetting;

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////
/*
CCedarReg::CCedarReg()
{

}

CCedarReg::~CCedarReg()
{

}
*/
BOOL CCedarReg::GetBinary(const CString& csSettingName)
{
	CRegKey regKey;
	DWORD   dwRead;
	
	LPCTSTR pazPath = L"SOFTWARE\\uema2\\CedarFTP\\Settings";
	long lResult = regKey.Open(HKEY_CURRENT_USER, pazPath);

	if (lResult == ERROR_SUCCESS)
	{
		regKey.Read(csSettingName, dwRead);

		regKey.Close();
	}
	if(dwRead==1) return TRUE;
	else          return FALSE;
}

BOOL CCedarReg::SetBinary(const CString& csSettingName, BOOL bCode)
{
	CRegKey regKey;
	DWORD   dwWrite;
	
	LPCTSTR pazPath = L"SOFTWARE\\uema2\\CedarFTP\\Settings";
	long lResult = regKey.Open(HKEY_CURRENT_USER, pazPath);

	if (lResult == ERROR_SUCCESS)
	{
		bCode ? dwWrite=1 : dwWrite=0;

		regKey.Write(csSettingName, dwWrite);

		regKey.Close();

		return TRUE;
	}
	return FALSE;
}

const CString& CCedarReg::GetString(const CString& csSettingName)
{
	CRegKey regKey;
	CString csTemp;

	LPCTSTR pazPath = L"Software\\uema2\\CedarFTP\\Settings";
	long lResult = regKey.Open(HKEY_CURRENT_USER, pazPath);

	if (lResult == ERROR_SUCCESS)
	{
		long lret = regKey.Read(csSettingName, csTemp);

		if(lret == ERROR_SUCCESS) csTempSetting = csTemp;
		else					  csTempSetting = L"";

		regKey.Close();
		return csTempSetting;
	}
	csTempSetting = L"";
	return csTempSetting;
}

void CCedarReg::SetString(const CString& csSettingName, const CString& csSetting)
{
	CRegKey regKey;
	CString string, csTemp;

	LPCTSTR pazPath = L"Software\\uema2\\CedarFTP\\Settings";
	long lResult = regKey.Open(HKEY_CURRENT_USER, pazPath);

	if (lResult == ERROR_SUCCESS)
	{
		regKey.Write(csSettingName, csSetting);

		regKey.Close();
	}

}

DWORD CCedarReg::GetDword(const CString& csSettingName)
{
	CRegKey regKey;
	DWORD dwTemp, dwRet;

	LPCTSTR pazPath = L"Software\\uema2\\CedarFTP\\Settings";
	long lResult = regKey.Open(HKEY_CURRENT_USER, pazPath);

	if (lResult == ERROR_SUCCESS)
	{
		long lret = regKey.Read(csSettingName, dwTemp);

		if(lret == ERROR_SUCCESS) dwRet = dwTemp;
		else					  dwRet = 0;

		regKey.Close();
		return dwRet;
	}
	return 0;
}

void CCedarReg::SetDword(const CString& csSettingName, const DWORD dwValue)
{
	CRegKey regKey;

	LPCTSTR pazPath = L"Software\\uema2\\CedarFTP\\Settings";
	long lResult = regKey.Open(HKEY_CURRENT_USER, pazPath);

	if (lResult == ERROR_SUCCESS)
	{
		regKey.Write(csSettingName, dwValue);

		regKey.Close();
	}
}
