// FtpSockCedarClient.cpp: CFtpSockCedarClient NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "CedarFTP.h"
#include "FtpSockCedarClient.h"

#include "UeUtil.h"
#include "MessageDialog.h"
#include "CedarReg.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CFtpSockCedarClient::CFtpSockCedarClient()
{

}

CFtpSockCedarClient::~CFtpSockCedarClient()
{

}

//////////////////////////////////////////////////////////////////////
// I[o[Ch֐
//////////////////////////////////////////////////////////////////////

BOOL CFtpSockCedarClient::ConnectToServer( CString csServer, UINT unPort )
{
	// PASV  ON ȂAPASVp\PbgH
	// PASV ptO𗧂ĂāAxɍs悤ɂ
	m_pasvflag = CCedarReg::GetBinary(L"UsePASV");

	return CFtpSockClient::ConnectToServer( csServer, unPort );
}

BOOL CFtpSockCedarClient::GetFile( CString csRemoteFile, CString csLocalFile )
{
	///// by uema2
	CMessageDialog md;

	md.m_message = L"ł\n΂炭҂";
	md.Create(IDD_MESSAGE_DIALOG);
	md.ShowWindow(SW_SHOW);
	/////

	if(m_pasvflag){
		// passive
		if( !OpenPasvDataChannel() )
			return ZERO;
	}else{
		// active
		if( !OpenDataChannel() )
			return ZERO;
	}

	CString csCommand = "RETR " + csRemoteFile;
	BOOL bRetVal = SendCommand( csCommand ); //by uema2.

	if(!m_pasvflag){
		GetResponse();
		if( !bRetVal || GetErrorCode() != DATA_OK )
		{
			m_SockSrvr.Close();
			return FALSE;
		}
	}

	CAsyncSocket	DataSocket;

	if(m_pasvflag) {
		if(!DataSocket.Create()) { 
			m_SockSrvr.Close();
#ifdef _DEBUG
	AfxMessageBox(L"PutFile::DataSocket.Creates");
#endif
			return ZERO;
		}
		DataSocket.Connect(m_csPasvServerName, m_PasvPort);
	}

	// accept inbound data connection from server
	if( !m_pasvflag  && !m_SockSrvr.Accept( DataSocket ) )
	{
		SetErrorCode ( ERR_SOCK_ACCEPT );
		DataSocket.Close();
		m_SockSrvr.Close();
		return FALSE; 
	}

	DWORD lpArgument=0;
	if(!DataSocket.IOCtl(FIONBIO,&lpArgument)) { 
		DataSocket.Close();
		m_SockSrvr.Close();
#ifdef _DEBUG
	AfxMessageBox(L"PutFile::DataSocket.IOCtls");
#endif
		return ZERO;
	}

	CFile	cfDataFile;

	if( ! cfDataFile.Open( csLocalFile, CFile::modeCreate | CFile::modeWrite ) )
	{
		SetErrorCode( ERR_SOCK_LOCFILE );
		return FALSE;
	}


	char szBuffer[ MAX_BUFFER ];
	int nNumBytesRead;
	CString csLocFileBuffer;
	int nNumTotalBytesRead=0; // by uema2.
	while ( TRUE )
	{
		memset( szBuffer, '\0', MAX_BUFFER );

		nNumBytesRead = DataSocket.Receive( szBuffer, MAX_BUFFER - 1 );

		if( ! nNumBytesRead || nNumBytesRead == SOCKET_ERROR ) 
			break; // ( EOF || network error )

		csLocFileBuffer += szBuffer; // by uema2.
		cfDataFile.Write( szBuffer, nNumBytesRead );

		/////by uema2.
		nNumTotalBytesRead += nNumBytesRead;
		md.m_message.Format(L"...%s\n%d/%d", csRemoteFile.Right(15), 
			nNumTotalBytesRead, m_FileSize);
//		md.m_message.Format(L"...%s\n%d", csRemoteFile.Right(15), 
//			nNumTotalBytesRead);
		md.UpdateData(FALSE);
		md.UpdateWindow();
		/////
	}

//	cfDataFile.Write( csLocFileBuffer, csLocFileBuffer.GetLength() ); // <-by uema2.

	DataSocket.Close();
	
	m_SockSrvr.Close();

	cfDataFile.Close();

	// G[擾
	DWORD dwError=0L;
	if(nNumBytesRead == SOCKET_ERROR){
		dwError = GetLastError();
	}

//	if(!m_pasvflag)
		GetResponse();

	// Dummy?
	if(m_pasvflag){
		BOOL bRetVal = SendCommand( "" );
		GetResponse();
	}

	if( GetErrorCode() != GET_OK )
		return FALSE;

	md.m_message = L"XVł\n΂炭҂";
	md.UpdateData(FALSE);
	md.UpdateWindow();
	md.DestroyWindow(); // by uema2.

	return (nNumBytesRead == SOCKET_ERROR) ? FALSE : TRUE;
}

BOOL CFtpSockCedarClient::PutFile( CString csLocalFile, CString csRemoteFile )
{
	///// by uema2
	CMessageDialog md;

	md.m_message = L"ł\n΂炭҂";
	md.Create(IDD_MESSAGE_DIALOG);
	md.ShowWindow(SW_SHOW);
	/////

	if(m_pasvflag){
		// passive
		if( !OpenPasvDataChannel() )
			return FALSE;
	}else{
		// active
		if( !OpenDataChannel() )
			return FALSE;
	}

	CString csCommand = "STOR " + csRemoteFile;

	BOOL bRetVal = SendCommand( csCommand );
	if(!m_pasvflag){
		GetResponse();
		if( !bRetVal || GetErrorCode() != DATA_OK ){
			m_SockSrvr.Close();
			return FALSE;
		}
	}
	
	CAsyncSocket	DataSocket;
	
	if(m_pasvflag) {
		if(!DataSocket.Create()) { 
			m_SockSrvr.Close();
			return FALSE;
		}
		DataSocket.Connect(m_csPasvServerName, m_PasvPort);
	}

	// accept inbound data connection from server
	if( !m_pasvflag  && !m_SockSrvr.Accept( DataSocket ) )
	{
		SetErrorCode ( ERR_SOCK_ACCEPT );
		DataSocket.Close();
		m_SockSrvr.Close();
		return FALSE; 
	}

	DWORD lpArgument=0;
	if(!DataSocket.IOCtl(FIONBIO,&lpArgument)) { 
		DataSocket.Close();
		m_SockSrvr.Close();
		return FALSE;
	}

	CFile	cfDataFile;

	if( ! cfDataFile.Open( csLocalFile, CFile::modeRead | CFile::shareDenyNone ) )
	{
		SetErrorCode( ERR_SOCK_LOCFILE );
		return FALSE;
	}

	char szBuffer[ MAX_BUFFER ];
	int nNumBytesRead;
	int nNumBytesSent;
	int nNumTotalBytesRead=0; //by uema2
	CString csLocFileBuffer;
	while ( TRUE )
	{
		memset( szBuffer,'\0', MAX_BUFFER );

		nNumBytesRead = cfDataFile.Read( szBuffer, MAX_BUFFER );
		
		if(! nNumBytesRead ) //EOF
			break; 
		
		if( ( nNumBytesSent = DataSocket.Send( szBuffer, nNumBytesRead, 0 )) == SOCKET_ERROR ) 
			break;
		
		/////by uema2.
		nNumTotalBytesRead += nNumBytesRead;
		md.m_message.Format(L"...%s\n%d/%d", csRemoteFile.Right(15),
			nNumTotalBytesRead, m_FileSize);
		md.UpdateData(FALSE);
		md.UpdateWindow();
		/////

		// if we sent fewer bytes than we read from file, rewind file pointer
		if( nNumBytesRead != nNumBytesSent ){
			cfDataFile.Seek( nNumBytesSent - nNumBytesRead, CFile::current );

			nNumTotalBytesRead -= nNumBytesRead; // by uema2.
		}
	}

	DataSocket.Close();
	
	m_SockSrvr.Close();

	cfDataFile.Close();


//	if(!m_pasvflag)
		GetResponse();

	// Dummy?
	if( m_pasvflag ){
		BOOL bRetVal = SendCommand( "" );
		GetResponse();
	}

	if( GetErrorCode() != GET_OK )
		return FALSE;

	md.m_message = L"XVł\n΂炭҂";
	md.UpdateData(FALSE);
	md.UpdateWindow();
	md.DestroyWindow(); // by uema2.

	return (nNumBytesSent == SOCKET_ERROR) ? FALSE : TRUE;
}

//////////////////////////////////////////////////////////////////////
// CFtpSockCedarClient ŗL̃o֐
//////////////////////////////////////////////////////////////////////

BOOL CFtpSockCedarClient::Upload(CString csLocalDir, CString csRemoteDir, CString csFileName,
								CArray <RemoteFileInfo, RemoteFileInfo> & remoteinfo)
{
	CString csLocalFile;
	// tpX𐶐
	if(csLocalDir==L"\\") csLocalFile = csLocalDir + csFileName;
	else csLocalFile = csLocalDir + L"\\" + csFileName;

	// t@C̏㏑mF
	if(TRUE==CCedarReg::GetBinary(L"CheckOverwrite")){

		// t@C邩ǂ{
		int j=0, iFind=0;
		while(iFind==0 && remoteinfo[j].m_filename!=L"*end*"){
			if(remoteinfo[j].m_filename==csFileName) iFind=1;
			j++;
		}
		
		// t@C݂Ȃ_CAOo
		if(iFind==1){
			int rc = AfxMessageBox(L"̃t@C͂łɑ݂܂B\n㏑܂H",
				MB_YESNO);
			if(rc==IDNO) return FALSE;
		}
	}

	// ʂONȂ
	if(CCedarReg::GetBinary(L"AutoTransferMode")){
		if(CUeUtil::CheckAsciiModeExt(csFileName)){
			// AXL[[h
			SetTransferModeAscii();
		}else{
			// oCi[h
			SetTransferModeImage();
		}
	}

	SetNumFileSize(CUeUtil::GetLocalFileSize(csLocalFile));

	// Abv[h
	BOOL bResult = PutFile( csLocalFile, csFileName ) ;
	if( ! bResult ){
		m_csStatusString = L"Abv[hɎs܂"; 
		return FALSE;
	}

	m_csStatusString = L"Abv[h܂"; 
	return TRUE;
}

BOOL CFtpSockCedarClient::Download(CString csLocalDir, CString csRemoteDir,
			CString csFileName, CArray <RemoteFileInfo, RemoteFileInfo> & remoteinfo)
{
	CString csLocalFile;
	// ۑ郍[Jt@C
	if(csLocalDir==L"\\") csLocalFile = csLocalDir + csFileName;
	else csLocalFile = csLocalDir + L"\\" + csFileName;

	// t@C̏㏑mF
	if(TRUE==CCedarReg::GetBinary(L"CheckOverwrite")){
		// t@C݂Ȃ_CAOo
		if(TRUE==CUeUtil::IsLocalFileExist(csLocalFile)){
			BOOL rc = AfxMessageBox(L"̃t@C͂łɑ݂܂B\n㏑܂H",
				MB_YESNO);
			if(rc!=IDYES) return FALSE;
		}
	}

	// t@C remoteinfo 猟At@CTCY擾
	int j=0, flag=0;
	while(flag==0 && remoteinfo[j].m_filename!=L"*end*"){
		if(remoteinfo[j].m_filename==csFileName) flag=1;
		j++;
	}

	// [gt@C
	if(csRemoteDir==L"/") csFileName = csRemoteDir + csFileName;
	else csFileName = csRemoteDir + L"/" + csFileName;

	SetNumFileSize(_ttoi(remoteinfo[j-1].m_filesize));

	// ʂONȂ
	if(CCedarReg::GetBinary(L"AutoTransferMode")){
		if(CUeUtil::CheckAsciiModeExt(csLocalFile)){
			// AXL[[h
			SetTransferModeAscii();
		}else{
			// oCi[h
			SetTransferModeImage();
		}
	}

	// _E[h
	BOOL bResult = GetFile( csFileName, csLocalFile ) ;
	if( ! bResult ){
		m_csStatusString = L"_E[hɎs܂"; 
//		m_progress.SetWindowText(L"_E[hɎs܂");	
//		continue;
		return FALSE;
	}
	m_csStatusString = L"_E[h܂"; 
	return TRUE;
}

