// LoginDialog.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "CedarFTP.h"
#include "LoginDialog.h"
#include "RegKey.h"
#include "CedarReg.h"
#include "UeUtil.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CLoginDialog _CAO


CLoginDialog::CLoginDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CLoginDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CLoginDialog)
	m_password = _T("");
	m_servername = _T("");
	m_username = _T("");
	m_savepass = FALSE;
	m_localdir = _T("");
	m_remotedir = _T("");
	//}}AFX_DATA_INIT
}


void CLoginDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLoginDialog)
	DDX_Control(pDX, IDC_COMBO1, m_combo);
	DDX_Text(pDX, IDC_PASSWORD, m_password);
	DDX_Text(pDX, IDC_SERVERNAME, m_servername);
	DDX_Text(pDX, IDC_USERNAME, m_username);
	DDX_Check(pDX, IDC_SAVEPASS, m_savepass);
	DDX_Text(pDX, IDC_LOCALDIR, m_localdir);
	DDX_Text(pDX, IDC_REMOTEDIR, m_remotedir);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CLoginDialog, CDialog)
	//{{AFX_MSG_MAP(CLoginDialog)
	ON_BN_CLICKED(IDB_SAVE, OnSave)
	ON_CBN_SELCHANGE(IDC_COMBO1, OnSelchangeCombo1)
	ON_BN_CLICKED(IDB_DELETE, OnDelete)
	ON_BN_CLICKED(IDB_SAVE, OnOK)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLoginDialog bZ[W nh

BOOL CLoginDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();

	// TODO: ̈ʒuɏ̕⑫ǉĂ
	CString csSetting;

	// ۑĂݒ萔擾
	// R{{bNX̏
	for(int i=0;i<10;i++){
		GetSettingName(i+1, csSetting);
		m_combo.InsertString(-1, csSetting);
	}
	m_combo.SetCurSel(0);

	// IDC_SAVEPASS ̃`FbN
	UpdateData(TRUE);
	if(1==CUeUtil::GetSavePass()) m_savepass=TRUE;

	// R{{bNXŐݒ肳Ăݒ薼ɂ
	// GfBbg{bNX𖄂߂
	GetSettingName(1, csSetting);

	LoadServerSettings(csSetting);
	if(m_savepass == FALSE) m_password = L"";
	UpdateData(FALSE);

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CLoginDialog::OnSave() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CString csSetting;

	// R{{bNXݒ薼擾
	m_combo.GetWindowText(csSetting);
	
	// R{{bNXȂx
	if(csSetting==L""){
		AfxMessageBox(L"R{{bNXɐݒ薼͂Ă\n");
		return;
	}

	// ۑ
	UpdateData(TRUE);
	if(m_savepass == FALSE) m_password = L"";
	SaveServerSettings(csSetting);

	// R{{bNX
	m_combo.ResetContent();
	for(int i=0;i<10;i++){
		GetSettingName(i+1, csSetting);
		m_combo.InsertString(-1, csSetting);
	}

}

void CLoginDialog::OnSelchangeCombo1() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CString csSetting;
	
	// ݒ薼Tēe\

	// R{{bNXݒ薼擾
	TCHAR temp[256];
	m_combo.GetLBText(m_combo.GetCurSel(), temp);
	csSetting = temp;

	// R{{bNXȂx
	if(csSetting==L""){
		UpdateData(TRUE);
		m_servername=L""; m_username=L""; m_password=L"";
		m_localdir = L""; m_remotedir = L"";
		UpdateData(FALSE);
		return;
	}

	UpdateData(TRUE);
	// ۑ
	LoadServerSettings(csSetting);

	if(m_savepass == FALSE) m_password = L"";
	UpdateData(FALSE);

}

void CLoginDialog::OnOK() 
{
	//IDC_SAVEPASS Z[u
	UpdateData(TRUE);
	CUeUtil::SetSavePass(m_savepass);

	CDialog::OnOK();
}

void CLoginDialog::OnDelete() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CString csSetting;

	// ݒ薼擾
	m_combo.GetWindowText(csSetting);

	// WXg
	DeleteServerSettings(csSetting);

	// R{{bNX
	m_combo.ResetContent();
	for(int i=0;i<10;i++){
		GetSettingName(i+1, csSetting);
		m_combo.InsertString(-1, csSetting);
	}
	m_combo.SetCurSel(0);

	// GfBbg{bNXNA
	UpdateData(TRUE);
	m_servername = L""; m_username = L""; m_password = L"";
	m_localdir = L""; m_remotedir = L"";
	UpdateData(FALSE);

}

/// ȉACUeUtil ϏĂ\bh

BOOL CLoginDialog::GetSettingName(int iServerName, CString& csSetting)
{
	CRegKey regKey;
	CString csTemp, csTemp2;

	LPCTSTR pazPath = L"Software\\uema2\\CedarFTP";
	long lResult = regKey.Open(HKEY_CURRENT_USER, pazPath);

	if (lResult == ERROR_SUCCESS)
	{
		csTemp.Format(L"SettingName%d", iServerName);
		long lret = regKey.Read(csTemp, csTemp2);

		if(lret == ERROR_SUCCESS) csSetting = csTemp2;
		else					  csSetting = L"";

		regKey.Close();
		return TRUE;
	}
	return FALSE;
}

int CLoginDialog::SeekServerSettings(const CString csSetting)
{
	CRegKey regKey;
	CString string;
	
	LPCTSTR pazPath = L"SOFTWARE\\uema2\\CedarFTP";
	long lResult = regKey.Open(HKEY_CURRENT_USER, pazPath);

	if (lResult == ERROR_SUCCESS)
	{
		//HKEY_CURRENT_USER\SOFTWARE\uema2\CedarFTP\SettingName當ǂݍ
		for(int i=1; i<=10; i++)
		{
			CString csTemp;
			csTemp.Format(L"SettingName%d", i);
			regKey.Read( csTemp, string );
			if(string==csSetting){
				// v΂̔ԍԂ
				regKey.Close();
				return i;
			}
		}
		regKey.Close();
	}

	return 0;
}


BOOL CLoginDialog::LoadServerSettings(const CString csSetting)
{
	// csServer -> m_servername
	// csName   -> m_username
	// csPass   -> m_password
	CRegKey regKey;
	CString string, csTemp, csTemp2;

	// vƂT
	int rc = SeekServerSettings(csSetting);

	if(rc == 0) return FALSE;

	LPCTSTR pazPath = L"Software\\uema2\\CedarFTP";
	long lResult = regKey.Open(HKEY_CURRENT_USER, pazPath);

	if (lResult == ERROR_SUCCESS)
	{
		csTemp.Format(L"Server%d", rc);
		long lret = regKey.Read(csTemp, csTemp2);
		if(lret == ERROR_SUCCESS) m_servername = csTemp2;
		else					  m_servername = L"";

		csTemp.Format(L"Name%d", rc);
		regKey.Read(csTemp, csTemp2);
		if(lret == ERROR_SUCCESS) m_username = csTemp2;
		else					  m_username = L"";

		csTemp.Format(L"Pass%d", rc);
		regKey.Read(csTemp, csTemp2);
		if(lret == ERROR_SUCCESS) m_password = csTemp2;
		else					  m_password = L"";

		csTemp.Format(L"LocalInitDir%d", rc);
		regKey.Read(csTemp, csTemp2);
		if(lret == ERROR_SUCCESS) m_localdir = csTemp2;
		else					  m_localdir = L"";

		csTemp.Format(L"RemoteInitDir%d", rc);
		regKey.Read(csTemp, csTemp2);
		if(lret == ERROR_SUCCESS) m_remotedir = csTemp2;
		else					  m_remotedir = L"";

		regKey.Close();

		return TRUE;
	}
	return FALSE;
}

void CLoginDialog::SaveServerSettings(const CString csSetting)
{
	// csServer -> m_servername
	// csName   -> m_username
	// csPass   -> m_password
	CRegKey regKey;
	CString string, csTemp;

	// SettingName ̂ƂT
	int rc = SeekServerSettings(L"");

	if( rc==0 )
	{
		AfxMessageBox(
			L"ۑł܂B\nݒۑ̏(10)" \
			L"BĂ\܂B");
		return;
	}

	LPCTSTR pazPath = L"Software\\uema2\\CedarFTP";
	long lResult = regKey.Open(HKEY_CURRENT_USER, pazPath);

	if (lResult == ERROR_SUCCESS)
	{
		csTemp.Format(L"SettingName%d", rc);
		regKey.Write(csTemp, csSetting);
			
		csTemp.Format(L"Server%d", rc);
		regKey.Write(csTemp, m_servername);
		csTemp.Format(L"Name%d", rc);
		regKey.Write(csTemp, m_username);
		csTemp.Format(L"Pass%d", rc);
		regKey.Write(csTemp, m_password);

		csTemp.Format(L"LocalInitDir%d", rc);
		regKey.Write(csTemp, m_localdir);

		csTemp.Format(L"RemoteInitDir%d", rc);
		regKey.Write(csTemp, m_remotedir);

		regKey.Close();
	}
}

BOOL CLoginDialog::DeleteServerSettings(const CString csSetting)
{
	CRegKey regKey;
	CString string, csTemp, csTemp2;

	int rc = SeekServerSettings(csSetting);

	if(rc == 0) return FALSE;

	LPCTSTR pazPath = L"Software\\uema2\\CedarFTP";
	long lResult = regKey.Open(HKEY_CURRENT_USER, pazPath);

	if (lResult == ERROR_SUCCESS)
	{

		csTemp.Format(L"SettingName%d", rc);
		regKey.Write(csTemp, L"");
			
		csTemp.Format(L"Server%d", rc);
		regKey.Write(csTemp, L"");
		csTemp.Format(L"Name%d", rc);
		regKey.Write(csTemp, L"");
		csTemp.Format(L"Pass%d", rc);
		regKey.Write(csTemp, L"");

		csTemp.Format(L"LocalInitDir%d", rc);
		regKey.Write(csTemp, L"");
		csTemp.Format(L"RemoteInitDir%d", rc);
		regKey.Write(csTemp, L"");

		regKey.Close();

		return TRUE;
	}

	return FALSE;
}

