// UeUtil.cpp: CUeUtil NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "CedarFTP.h"
#include "UeUtil.h"
#include "RegKey.h"
#include "CedarReg.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////
BOOL CUeUtil::GetSavePass()
{
	CRegKey regKey;
	DWORD   dwRead;
	
	LPCTSTR pazPath = L"SOFTWARE\\uema2\\CedarFTP";
	long lResult = regKey.Open(HKEY_CURRENT_USER, pazPath);

	if (lResult == ERROR_SUCCESS)
	{
		regKey.Read(L"SavePass", dwRead);

		regKey.Close();
	}
	if(dwRead==1) return TRUE;
	else          return FALSE;
}


BOOL CUeUtil::SetSavePass(BOOL bCode)
{
	CRegKey regKey;
	DWORD   dwWrite;
	
	LPCTSTR pazPath = L"SOFTWARE\\uema2\\CedarFTP";
	long lResult = regKey.Open(HKEY_CURRENT_USER, pazPath);

	if (lResult == ERROR_SUCCESS)
	{
		bCode ? dwWrite=1 : dwWrite=0;

		regKey.Write(L"SavePass", dwWrite);

		regKey.Close();

		return TRUE;
	}
	return FALSE;
}

void CUeUtil::GetRemoteFileInfo(CString csList, 
								BOOL& bDir,
								CString& csFileName, CString& csPermission, 
								CString& csFileSize, CString& csDate)
{
	// format
	// --rw-rw-rw 1 0000/0000   8733 May 12 19:11 index.html
	// 53 + "\n" ?

	CString csTemp, retcode=L"\r";
	int iPos=0, iPosRev, iLength;

	// p[~bV擾
	iPos = csList.Find(L' ');
//	csPermission = csList.Left(iPos-1);
	csPermission = csList.Left(iPos);

	// fBNgǂ
	bDir = csPermission[0]==L'd'?1:0;

	// t@C擾
	iLength = csList.GetLength();
	iPosRev = csList.ReverseFind(L' ');
	if(csList[iLength-1]==retcode){
		// ĂƂBʏ
		csFileName = csList.Mid(iPosRev+1, iLength - iPosRev - 2);
	}else{
		// I[ɉȂƂ
		csFileName = csList.Mid(iPosRev+1, iLength - iPosRev - 1);
	}

	// tE擾
	csDate = csList.Mid(iPosRev-12, 12);

	// 
	csFileSize = L"";

	// t@CTCY擾
	if(bDir==0){
		int i = iPosRev-14;
//		while(csList.Mid(i, 1)!=L" "){
		while(csList[i]!=L' '){
			csFileSize = csList.Mid(i, 1) + csFileSize;
			i--;
		}
	}else{
		csFileSize = L"----";
	}

}

int CUeUtil::TranslatePermission(CString csPermission)
{
/*
	0 ---  
	1 --x  
	2 -w-  
	3 -wx  
	4 r--  
	5 r-x  
	6 rw-  
	7 rwx 
*/
	int iOwner=0, iGroup=0, iAll=0;

	if(csPermission[1]==L'r') iOwner+=4;
	if(csPermission[2]==L'w') iOwner+=2;
	if(csPermission[3]==L'x') iOwner+=1;
	if(csPermission[4]==L'r') iGroup+=4;
	if(csPermission[5]==L'w') iGroup+=2;
	if(csPermission[6]==L'x') iGroup+=1;
	if(csPermission[7]==L'r') iAll+=4;
	if(csPermission[8]==L'w') iAll+=2;
	if(csPermission[9]==L'x') iAll+=1;

	return iOwner*100 + iGroup*10 + iAll;
}


BOOL CUeUtil::CheckAsciiModeExt(const CString &csFileName)
{
//	int start=0, end=0;
	int position, exit=0;
	CString csExtLine, csExt;

	// csExtLine WXg擾
	csExtLine = CCedarReg::GetString(L"AutoTransferModeList");
	
	while(exit!=1){
		// ڒo
		position = csExtLine.Find(L" ");
		if(position==-1){
			 csExt = csExtLine;
//			 exit=1;
		}else{
			csExt = csExtLine.Left(position);
		}


//	AfxMessageBox(csExt);

		// r
		if(csFileName.Right(csExt.GetLength()) == csExt)
			// v 1 Ԃ
			return 1;

		if(position==-1) exit=1;

		// rIڂ
		csExtLine = csExtLine.Right(csExtLine.GetLength()-position-1);
//	AfxMessageBox(csExtLine);

	}
/*
	// Âr
	while(1){
		end = csExtLine.Find(L' ', start);
		if(end==-1) break;
		csExt = csExtLine.Mid(start, end+1);

		if(csFileName.Right(csExt.GetLength()) == csExt){
			// v 1 Ԃ
			return 1;
		}
		start = end + 1;
	}
*/	
	// vȂ 0 Ԃ
	return 0;
}

int CUeUtil::GetLocalFileSize(const CString& csFile)
{
	CFile cf(csFile,CFile::modeRead);
	return cf.GetLength();
}

BOOL CUeUtil::IsLocalFileExist(const CString& csLocalFile)
{
	HANDLE hFile = CreateFile(csLocalFile,
		GENERIC_READ, FILE_SHARE_READ,
		NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);

	// JȂ֐ŝŁA
	// t@C݂͑Ȃ
	if(hFile == INVALID_HANDLE_VALUE)
		return FALSE;
	
	CloseHandle(hFile);
	return TRUE;
}

VOID WINAPI CUeUtil::RasCallback( UINT unMsg, 
					RASCONNSTATE rasconnstate, 
					DWORD dwError) 
{
	// ڑ 
	if( rasconnstate == RASCS_ConnectDevice ){
//		::SetDlgItemText( hWnd, IDC_EDIT1, "ڑ");     
	}

	// ڑJni|[gI[vj 
	if( rasconnstate == RASCS_PortOpened ){
//		::SetDlgItemText( hWnd, IDC_EDIT1, 
//						"|[gI[v");     
    }

    // ڑ 
    if( rasconnstate == RASCS_DeviceConnected ){
//		::SetDlgItemText( hWnd, IDC_EDIT1, "ڑ");     
    }

   // [U[ƃpX[hmF 
    if( rasconnstate == RASCS_Authenticate ){
//		::SetDlgItemText( hWnd, IDC_EDIT1, "Fؒ");     
    }

    // [U[F؊ 
    if( rasconnstate == RASCS_Authenticated ){
//		::SetDlgItemText( hWnd, IDC_EDIT1, "F؊");     
    }

    // ڑ 
    if( rasconnstate == RASCS_Connected ){
//		::SetDlgItemText( hWnd, IDC_EDIT1, "ڑ");     
    }

}

void CUeUtil::putLog(const CString& stat)
{
#ifdef DEBUG
	HANDLE h = ::CreateFile( L"\\cedftp.log", GENERIC_WRITE, 0,
		NULL, OPEN_ALWAYS, 0, NULL );

	if( h==INVALID_HANDLE_VALUE )
		return;

	::SetFilePointer( h, 0L, NULL, FILE_END );

	DWORD d;
	TCHAR n[3]={0x0d, 0x0a, 0x00};
	::WriteFile( h, (LPCTSTR)stat, _tcslen(stat)*2, &d, NULL );
	::WriteFile( h, n, 4, &d, NULL );

	::CloseHandle(h);
#endif
}

