// PermissionDialog.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "CedarFTP.h"
#include "PermissionDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPermissionDialog _CAO


CPermissionDialog::CPermissionDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CPermissionDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPermissionDialog)
	m_all_r = FALSE;
	m_all_w = FALSE;
	m_all_x = FALSE;
	m_grp_r = FALSE;
	m_grp_w = FALSE;
	m_grp_x = FALSE;
	m_own_r = FALSE;
	m_own_w = FALSE;
	m_own_x = FALSE;
	m_current = _T("");
	//}}AFX_DATA_INIT
}


void CPermissionDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPermissionDialog)
	DDX_Check(pDX, IDC_ALL_R, m_all_r);
	DDX_Check(pDX, IDC_ALL_W, m_all_w);
	DDX_Check(pDX, IDC_ALL_X, m_all_x);
	DDX_Check(pDX, IDC_GROUP_R, m_grp_r);
	DDX_Check(pDX, IDC_GROUP_W, m_grp_w);
	DDX_Check(pDX, IDC_GROUP_X, m_grp_x);
	DDX_Check(pDX, IDC_OWNER_R, m_own_r);
	DDX_Check(pDX, IDC_OWNER_W, m_own_w);
	DDX_Check(pDX, IDC_OWNER_X, m_own_x);
	DDX_Text(pDX, IDC_CURRENT, m_current);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPermissionDialog, CDialog)
	//{{AFX_MSG_MAP(CPermissionDialog)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPermissionDialog bZ[W nh

void CPermissionDialog::GetCurrentPermission(
		CArray <RemoteFileInfo, RemoteFileInfo>& ri, int i)
{
	CString csCurrentPermission;

	m_own_r = ri[i].m_permission[1] == L'r';
	m_own_w = ri[i].m_permission[2] == L'w';
	m_own_x = ri[i].m_permission[3] == L'x';
	m_grp_r = ri[i].m_permission[4] == L'r';
	m_grp_w = ri[i].m_permission[5] == L'w';
	m_grp_x = ri[i].m_permission[6] == L'x';
	m_all_r = ri[i].m_permission[7] == L'r';
	m_all_w = ri[i].m_permission[8] == L'w';
	m_all_x = ri[i].m_permission[9] == L'x';

	csCurrentPermission.Format(L"݂̑F%d", 
		CUeUtil::TranslatePermission(ri[i].m_permission));
	m_current = csCurrentPermission;
}

void CPermissionDialog::GetNewPermission(CString& csPermission)
{
	int iOwner=0, iGroup=0, iAll=0;

	// Rg[̏Ԃ
	// ep[~bV擾
	if(m_own_r) iOwner += 4; if(m_own_w) iOwner += 2; if(m_own_x) iOwner += 1;
	if(m_grp_r) iGroup += 4; if(m_grp_w) iGroup += 2; if(m_grp_x) iGroup += 1;
	if(m_all_r) iAll += 4; if(m_all_w) iAll += 2; if(m_all_x) iAll += 1;

	// 3̐ɂĕԂ
	csPermission.Format(L"%d%d%d", iOwner, iGroup, iAll);
}

